<?php
	/**
	 * get weather status
	 * @param integer $placeID: 地區代碼 (數字)
	 * @param integer $expire: 多久後重新取得資料 (單位：分，0：不使用 cache)
	 * @return integer $status: 該地區的天氣狀況
	 **/
	function getWeatherStatus($placeID, $expire=0) {
		$mapPlace = array(
			'',
			'TAIPEI-CITY', 'KAOHSIUNG-CITY', 'KEELUNG' ,
			'TAIPEI'     , 'TAOYUAN'       , 'HSINCHU' ,
			'MIAOLI'     , 'TAICHUNG'      , 'CHANGHUA',
			'NANTOU'     , 'YUNLIN'        , 'CHIAYI'  ,
			'TAINAN'     , 'KAOHSIUNG'     , 'PINGTUNG',
			'HENGCHUN'   , 'YILAN'         , 'HUALIEN' ,
			'TAITUNG'    , 'PENGHU'        , 'KINMEN'  ,
			'MASTSU'
		);

		$pid = max(1, min(22, intval($placeID)));

		// read cache data
		$fna = 'weather_cache.txt';
		$che = array();
		if (file_exists($fna)) {
			$txt = file_get_contents($fna);
			$che = unserialize($txt);
			if (array_key_exists($pid, $che)) {
				if ((time() - $che[$pid][0]) < (intval($expire) * 60)) {
					// echo 'cache: ';
					return $che[$pid][1];
				}
			}
		}

		// $url = sprintf('http://www.cwb.gov.tw/V5/forecast/taiwan/36_%02d_data.htm', $pid);
		$url = 'http://www.cwb.gov.tw/pda/forecast/' . $mapPlace[$pid] . '.htm';
		$txt = file_get_contents($url);
		$sta = preg_match('/src="\/V5\/symbol\/symbol(\d+)\.gif"/', $txt, $res);
		// write cache data
		$che[$pid] = array(time(), $res[1]);
		$fp = @fopen($fna, 'w');
		@fwrite($fp, serialize($che));
		fclose($fp);

		return $res[1];
	}

	$staID = getWeatherStatus($_GET['pid'], 1);
	echo $staID;
	echo '<br />';
	echo '<img src="http://www.cwb.gov.tw/V5/symbol/symbol' . $staID . '.gif">';
	echo '<br />';
	$staID = getWeatherStatus($_GET['pid'], 10);
	echo $staID;
?>